#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <queue>
#include <set>
using namespace std;

#define vii vector<int>
#define ll long long
#define vll vector<ll>
#define pii pair<int, int>
#define pll pair<ll, ll>
#define f first
#define s second

int n;
vii a;
vii used;

ll answ;

void cnt(ll cur, ll people)
{
    if(cur >= n)
    {
        answ = max(answ, people);
        return;
    }

    if(used[cur] == 0 && (a[cur] == -1 || used[a[cur]] == 0))
    {
        if(a[cur] != -1)
            used[a[cur]]++;

        cnt(cur + 1, people + 1);

        if(a[cur] != -1)
            used[a[cur]]--;
    }

    cnt(cur + 1, people);
}

int main()
{
    cin >> n;
    answ = 0;

    a.resize(n);
    used.resize(n);
    for(int i = 0; i < a.size(); i++)
    {
        cin >> a[i];
        if(a[i] != -1)
            a[i]--;
    }

    if(n <= 20)
    {
        cnt(0, 0);
        cout << answ << endl;
        return 0;
    }
    cout << (n + 1) / 2 << endl;
    return 0;
}
